<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }

class user
{
    Private $Reg;
    private $data = array();

    public function __construct($Registry){
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","User Class");

        $route_methods = array("login","logout","show_admins","admin_edit","admin_add","admin_delete","forgot","forgotpass","reset","resetpass");
        $this->Reg->route->set_route("user", $route_methods);
    }

    public function valid($ajax=null)
    {
        if(isset($_SESSION['valid']) && $_SESSION['valid'] == "y"){return true; }
        session_destroy();
        if(!$ajax){
            $data['page_title_extra'] = "Login";
        $this->Reg->tpl->set_section("public");
        $this->Reg->tpl->showview("login",$data);
        }
        exit;
    }

    public function login()
    {
        $data['page_title_extra'] = "Login";
        if(!isset($_POST['login']))
        {
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("login",$data);
        }

        $this->data['username'] = $this->Reg->security->get("username","post");
        $this->data['password'] = $this->Reg->security->get("password","post");

        if($this->data['username'] == "")
        {
            $this->Reg->error->raise_error("form","Username is blank.","public");
        }
        if($this->data['password'] == "")
        {
            $this->Reg->error->raise_error("form","Password is blank.","public");
        }
        if($this->Reg->error->is_errors("form")){
            $this->Reg->tpl->set_section("public");

            $this->Reg->tpl->showview("login",$data);
        }

        if(!$this->Reg->security->validate($this->data['username'],"match",'/^[A-Za-z0-9]{5,30}+$/i') ||
            !$this->Reg->security->validate($this->data['password'],"match",'/^[A-Za-z0-9]{5,30}+$/i'))
        {
            $this->Reg->error->raise_error("form","Invalid Login","public");
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("login",$data);
        }

        if($this->Reg->settings->Config('database_type') == 'file')
        {

            if($this->Reg->settings->Config('admin_username') == $this->data['username'] &&
                $this->Reg->settings->Config('admin_password') == $this->data['password'] ){
                //valid login
                $_SESSION['valid'] = "y";
                $this->Reg->route->home(true);
            }
        }

        if($this->Reg->settings->Config('database_type') == 'mysql')
        {
           $username = mysql_real_escape_string($this->data['username']);
           $password = mysql_real_escape_string(md5($this->data['password']));

            $sql = "SELECT * FROM admin WHERE username = '$username' AND password = '$password' LIMIT 1";
            if($result = $this->Reg->db->get_row($sql))
            {
                $ip = mysql_real_escape_string($_SERVER['REMOTE_ADDR']);
                $memid = $result->id;
                $lastip = $result->ip;
                $lastlogin = $result->curlogin;
                $master = $result->master;
                $sql = "UPDATE admin SET ip = '$ip', lastlogin = '$lastlogin', lastip = '$lastip', curlogin = NOW() WHERE id = '$memid'";
                $this->Reg->db->query($sql);

                $_SESSION['valid'] = "y";
                $_SESSION['memid'] = $memid;
                $_SESSION['master'] = $master;
                $this->Reg->route->home(true);
            }

        }

        $this->Reg->error->raise_error("form","Invalid Login","public");
        $this->Reg->tpl->set_section("public");
        $this->Reg->tpl->showview("login",$data);
    }

    public function logout()
    {
        session_destroy();
        $data['page_title_extra'] = "Login";
        $this->Reg->tpl->set_section("public");
        $this->Reg->route->home(true);
    }


    public function show_admins()
    {
        $this->valid(true);
        $page = $this->Reg->security->get("page","post");
        $limit = $this->Reg->security->get("rows","post");
        $sidx = $this->Reg->security->get("sidx","post");
        $sord = $this->Reg->security->get("sord","post");
        $sidx =1;

        $sql = "SELECT COUNT(*) AS count FROM shortlinks";
        $count = $this->Reg->db->get_var($sql);
        if( $count >0 ) {
            $total_pages = ceil($count/$limit);
        } else { $total_pages = 0; }

        if ($page > $total_pages)
            $page=$total_pages;

        $start = $limit*$page - $limit;

        $limit = mysql_real_escape_string($limit);
        $sord = mysql_real_escape_string($sord);

        if(isset($_SESSION['master']) && $_SESSION['master'] == "y"){
            $sql = "SELECT id,username,email FROM admin ORDER BY $sidx $sord LIMIT $start , $limit";
        } else {
            $memid = mysql_real_escape_string($_SESSION['memid']);
            $sql = "SELECT id,username,email FROM admin WHERE id = '$memid' LIMIT 1";
        }


        if($result = $this->Reg->db->get_results($sql))
        {
            $responce = array();
            $responce['page'] = $page;
            $responce['total'] = $total_pages;
            $responce['records'] = $count;
            $i=0;

            foreach ( $result as $row )
            {
                $responce['rows'][$i]['id']=$row->id;
                $responce['rows'][$i]['cell']=array($row->username,$row->email,"","");
                $i++;
            }
        }
        echo json_encode($responce);
    }

    public function admin_edit()
    {
        $this->Reg->user->valid(true);
        $this->get_data();

        if($_SESSION['master'] == 'n')
        {
            if($this->data['id'] != $_SESSION['memid'])
            {
                exit;
            }
        }

        $this->data['id'] = mysql_real_escape_string($this->data['id']);
        $this->data['username'] = mysql_real_escape_string($this->data['username']);
        $this->data['email'] = mysql_real_escape_string($this->data['email']);

        $varadmin = $this->Reg->db->get_var("SELECT count(*) FROM admin WHERE id != '".$this->data['id']."' AND username = '".$this->data['username']."'");
        if($varadmin > 0) { echo "<b>Error</b><br />An account with that username already exists."; exit; }

        $varadmin = $this->Reg->db->get_var("SELECT count(*) FROM admin WHERE id != '".$this->data['id']."' AND email = '".$this->data['email']."'");
        if($varadmin > 0) { echo "<b>Error</b><br />An account with that email address already exists."; exit; }

        if($this->data['password'] != ""){
        $this->data['password'] = mysql_real_escape_string(md5($this->data['password']));
            $sql = "UPDATE admin SET username = '".$this->data['username']."', email = '".$this->data['email']."', password = '".$this->data['password']."' WHERE id = '".$this->data['id']."'";
        } else {
        $sql = "UPDATE admin SET username = '".$this->data['username']."', email = '".$this->data['email']."' WHERE id = '".$this->data['id']."'";
        }

        $this->Reg->db->query($sql);
        if ( $this->Reg->db->is_error() ){ echo "<b>Error</b><br />There was a problem editing the admin account."; }

    }

    public function admin_add()
    {
        $this->Reg->user->valid(true);
        if($_SESSION['memid'] != 1){ exit; }
        $this->get_data();

        $this->data['id'] = mysql_real_escape_string($this->data['id']);
        $this->data['username'] = mysql_real_escape_string($this->data['username']);
        $this->data['email'] = mysql_real_escape_string($this->data['email']);
        $this->data['password'] = mysql_real_escape_string(md5($this->data['password']));

        $varadmin = $this->Reg->db->get_var("SELECT count(*) FROM admin WHERE username = '".$this->data['username']."'");
        if($varadmin > 0) { echo "<b>Error</b><br />An account with that username already exists."; exit; }

        $varadmin = $this->Reg->db->get_var("SELECT count(*) FROM admin WHERE email = '".$this->data['email']."'");
        if($varadmin > 0) { echo "<b>Error</b><br />An account with that email address already exists."; exit; }

        $sql = "INSERT INTO admin (id,username,email,password,ip,lastlogin,lastip,curlogin,pkey,master)
VALUES (null,'".$this->data['username']."', '".$this->data['email']."','".$this->data['password']."','','','','','','n')";
        $this->Reg->db->query($sql);
        if ( $this->Reg->db->is_error() ){ echo "<b>Error</b><br />There was a problem creating the new admin account."; }
    }

    public function admin_delete()
    {
        $this->Reg->user->valid(true);
        if($_SESSION['memid'] != 1){ exit; }

        $this->data['id'] = $this->data['id'] = $this->Reg->security->get("id","post","int");

        if(!$this->Reg->security->validate($this->data['id'],"match",'/^[0-9]+$/i'))
        {
            $this->Reg->error->raise_error("general","Invalid Id","admin");
        }

        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }
        if($this->data['id'] == 1){ echo "You can not delete the master admin account"; exit; }

        $sql = "DELETE FROM admin WHERE id = '".$this->data['id']."'";
        $this->Reg->db->query($sql);
        if($this->Reg->db->is_error()) { echo "<b>Error</b><br />There was a problem deleting the selected admin account."; }
    }

    private function get_data($doing_edit=false)
    {

        $this->data['id'] = $this->Reg->security->get("id","post","int");
        $this->data['username'] = $this->Reg->security->get("username","post");
        $this->data['email'] = $this->Reg->security->get("email","post","email");
        $this->data['password'] = $this->Reg->security->get("password","post");
        $this->data['password2'] = $this->Reg->security->get("password2","post");

        if($doing_edit){
        if($this->data['id'] == ""){ $this->Reg->error->raise_error("general","Invalid Id","admin"); }
        if($this->data['password'] == ""){ $this->Reg->error->raise_error("general","Password is empty","admin"); }
        }
        if($this->data['username'] == ""){ $this->Reg->error->raise_error("general","Username is empty","admin"); }
        if($this->data['email'] == ""){ $this->Reg->error->raise_error("general","Email is empty","admin"); }

        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }


        if($doing_edit)
        {
            if(!$this->Reg->security->validate($this->data['id'],"match",'/^[0-9]+$/i'))
            {
                    $this->Reg->error->raise_error("general","Invalid Id","admin");
            }
        }

        if(!$this->Reg->security->validate($this->data['username'],"match",'/^[0-9a-zA-Z]{5,30}+$/i'))
        {
            $this->Reg->error->raise_error("general","Username can only contain alphanumeric characters and be between 5 and 30 characters long.","admin");
        }
        if(!$this->Reg->security->validate($this->data['email'],"email"))
        {
            $this->Reg->error->raise_error("general","Invalid URL detected.","admin");
        }
        if($this->data['password'] != "")
        {
            if(!$this->Reg->security->validate($this->data['password'],"match",'/^[0-9a-zA-Z]{5,30}+$/i'))
            {
                $this->Reg->error->raise_error("general","Password can only contain alphanumeric characters and be between 5 and 30 characters long.","admin");
            }
        }
        if($this->data['password'] != $this->data['password2'])
        {
            $this->Reg->error->raise_error("general","Passwords do not match.","admin");
        }

        if($this->Reg->error->is_errors("general"))
        {
            $error_out = "<b>Error</b><br />";
            $error_out .= $this->Reg->error->get_general();
            echo $error_out;
            exit;
        }
        return;
    }

    public function forgot()
    {
        if($this->Reg->settings->Config('database_type') != 'mysql'){ exit; }
        $data['page_title_extra'] = "Forgot Password";
        $this->Reg->tpl->set_section("public");
        $this->Reg->tpl->showview("forgot",$data);
    }

    public function forgotpass()
    {
        $data['page_title_extra'] = "Forgot Password";
        $this->data['email'] = $this->Reg->security->get("email","post","email");
        if($this->data['email'] == ""){ $this->Reg->error->raise_error("form","Email is empty","admin"); }

        if($this->Reg->error->is_errors("form"))
        {
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("forgot",$data);
        }

        if(!$this->Reg->security->validate($this->data['email'],"email"))
        {
            $this->Reg->error->raise_error("form","Invalid email detected.","admin");
        }

        if($this->Reg->error->is_errors("form"))
        {
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("forgot",$data);
        }


        $this->data['email'] = mysql_real_escape_string($this->data['email']);
        $sql = "SELECT id FROM admin WHERE email = '".$this->data['email']."' LIMIT 1";
        if($row = $this->Reg->db->get_row( $sql )){

            $memid = $row->id;
            $mailkey = md5( uniqid() );
            $maillink = $this->Reg->settings->Config("site_url")."/admin.php/user/reset/".$mailkey;
            $sql = "UPDATE admin SET pkey = '$mailkey' WHERE id = '$memid'";
            $this->Reg->db->query( $sql );

            $to      = $this->data['email'];
            $subject = 'Password Reset';
            $message = "Hello,

To reset your password please visit the below link.

$maillink

Best Wishes
BZ9.com Link Cracker
";
            $headers = 'From: linkcracker@bz9.com' . "\r\n" .
                'Reply-To: '.$to.'' . "\r\n" .
                'X-Mailer: BZ9 Link Cracker';

            @mail($to, $subject, $message, $headers);
            $this->Reg->error->raise_error("form","Please check your email for further details","admin");
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("forgot",$data);
        } else {
            $this->Reg->error->raise_error("form","E-mail is not valid","admin");
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("forgot",$data);
        }
    }

    public function reset()
    {
        $data['page_title_extra'] = "Forgot Password";
        $resetkey = $this->Reg->settings->config('request1');

        if($resetkey == ""){ exit; }

            if(!$this->Reg->security->validate($resetkey,"match",'/^[0-9a-zA-Z]+$/i'))
            {
                exit;
            }

            $resetkey = mysql_real_escape_string($resetkey);
            $sql = "SELECT id FROM admin WHERE pkey = '$resetkey' LIMIT 1";
        if($row = $this->Reg->db->get_row( $sql )){
                $_SESSION['resetid'] = $row->id;
            $_SESSION['resetkey'] = $resetkey;
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("resetpass",$data);
            }
        exit;
    }

    public function resetpass()
    {
        $data['page_title_extra'] = "Login";
        if(!isset($_SESSION['resetid'])){ exit; }
        if($_SESSION['resetid'] == ""){ exit; }
        if(!isset($_SESSION['resetkey'])){ exit; }
        if($_SESSION['resetkey'] == ""){ exit; }
        if(!$this->Reg->security->validate($_SESSION['resetid'],"match",'/^[0-9]+$/i'))
        {
            exit;
        }
        if(!$this->Reg->security->validate($_SESSION['resetkey'],"match",'/^[0-9a-zA-Z]+$/i'))
        {
            exit;
        }

        $this->data['password'] = $this->Reg->security->get("password","post");
        $this->data['password2'] = $this->Reg->security->get("password2","post");

        if($this->data['password'] == ""){ $this->Reg->error->raise_error("form","Password is empty","admin"); }

        if(!$this->Reg->security->validate($this->data['password'],"match",'/^[0-9a-zA-Z_]{5,30}+$/i'))
        {
            $this->Reg->error->raise_error("form","Password can only contain alphanumeric characters along with _ and be between 5 and 30 characters long.","admin");
        }

        if($this->Reg->error->is_errors("form"))
        {
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("resetpass",$data);
        }


        if($this->data['password'] != $this->data['password2'])
        {
            $this->Reg->error->raise_error("form","Passwords do not match.","admin");
        }
        if($this->Reg->error->is_errors("form"))
        {
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("resetpass",$data);
        }

        $this->data['password'] = mysql_real_escape_string(md5($this->data['password']));

        $memid = mysql_real_escape_string($_SESSION['resetid']);
        $resetkey = mysql_real_escape_string($_SESSION['resetkey']);

        $sql = "UPDATE admin SET password = '".$this->data['password']."', pkey = '' WHERE id = '$memid' AND pkey = '$resetkey'";
        $this->Reg->db->query($sql);
        if(!$this->Reg->db->is_error()){
            $this->Reg->error->raise_error("form","Password Updated","admin");
            $data['page_title_extra'] = "Login";
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("login",$data);
        } else {
            $this->Reg->error->raise_error("form","There was a problem resetting the password","admin");
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("resetpass",$data);
        }
        exit;

    }

}
